% gl_softth - soft threshold function for grouped L1 regularization
% 
% Copyright(c) 2009 Ryota Tomioka
% This software is distributed under the MIT license. See license.txt

function vv=gl_softth(vv, lambda)

nm = sqrt(sum(vv.^2));
I0=find(nm<=lambda);
I1=find(nm>lambda);

vv(:,I0)=0;
vv(:,I1)=vv(:,I1)*spdiag((nm(I1)-lambda)./nm(I1));

