% l1_stopcond_pdg - "primal-dual" stopping condition for L1
%                   regularization
%
% Copyright(c) 2009 Ryota Tomioka
% This software is distributed under the MIT license. See license.txt

function [ret, res]=l1_stopcond_pdg(fnc, ww, A, AT, lambda, floss, gg, tol)

aa    = min(1, lambda/max(abs(AT(gg))))*gg;
dloss = fnc.d(aa, fnc.args{:});
fval  = floss+lambda*sum(abs(ww));
res   = fval-(-dloss);
res   = res/fval;

ret   = (res<tol);


